package anywheresoftware.b4a.b4abridge;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.b4abridge", "anywheresoftware.b4a.b4abridge.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.b4abridge", "anywheresoftware.b4a.b4abridge.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "anywheresoftware.b4a.b4abridge.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
//        try {
//            if (processBA.subExists("activity_actionbarhomeclick")) {
//                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
//                    getClass().getMethod("getActionBar").invoke(this), true);
//                BA.Log("adding event");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
		return true;
	}   
// @Override
// public boolean onOptionsItemSelected(android.view.MenuItem item) {
//    if (item.getItemId() == 16908332) {
//        processBA.raiseEvent(null, "activity_actionbarhomeclick");
//        return true;
//    }
//    else
//        return super.onOptionsItemSelected(item); 
//}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.SocketWrapper.ServerSocketWrapper _server = null;
public static String _folder = "";
public static String _version = "";
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _badmin = null;
public static boolean _waitingforbluetoothtobeready = false;
public static boolean _waitingforreset = false;
public static anywheresoftware.b4a.objects.Timer _resettimer = null;
public static int _lastenabled = 0;
public anywheresoftware.b4a.objects.LabelWrapper _lblip = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblstatus = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblversion = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnstartbluetooth = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnstartwireless = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _chkdiscoverable = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnresetbluetooth = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnstop = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnrestart = null;
public anywheresoftware.b4a.b4abridge.service1 _service1 = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 37;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 38;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 39;BA.debugLine="server.Initialize(0, \"\")";
_server.Initialize(processBA,(int) (0),"");
 //BA.debugLineNum = 40;BA.debugLine="BAdmin.Initialize(\"BAdmin\")";
_badmin.Initialize(processBA,"BAdmin");
 //BA.debugLineNum = 41;BA.debugLine="resetTimer.Initialize(\"resetTimer\", 1000)";
_resettimer.Initialize(processBA,"resetTimer",(long) (1000));
 };
 //BA.debugLineNum = 43;BA.debugLine="Activity.LoadLayout(\"1\")";
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 //BA.debugLineNum = 44;BA.debugLine="lblVersion.Text = \"B4A-Bridge v\" & version";
mostCurrent._lblversion.setText((Object)("B4A-Bridge v"+_version));
 //BA.debugLineNum = 45;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 104;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 106;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 47;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 48;BA.debugLine="UpdateIp";
_updateip();
 //BA.debugLineNum = 49;BA.debugLine="UpdateStatus";
_updatestatus();
 //BA.debugLineNum = 50;BA.debugLine="btnStartBluetooth.Enabled = False";
mostCurrent._btnstartbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 51;BA.debugLine="btnStartWireless.Enabled = False";
mostCurrent._btnstartwireless.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 52;BA.debugLine="btnResetBluetooth.Enabled = False";
mostCurrent._btnresetbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 53;BA.debugLine="If File.ExternalWritable = False Then";
if (anywheresoftware.b4a.keywords.Common.File.getExternalWritable()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 54;BA.debugLine="Msgbox(\"Storage card not available. Make sure that your device is not connected in USB storage mode.\", \"Attention\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Storage card not available. Make sure that your device is not connected in USB storage mode.","Attention",mostCurrent.activityBA);
 }else if(_checknonmarketappsenabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 56;BA.debugLine="Msgbox(\"Please enable installation of non-market appplications.\" & CRLF & \"Under Settings - Security - Unknown sources\" _ 			 & CRLF & \"Or Settings - Applications - Unknown sources\", \"Attention\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Please enable installation of non-market appplications."+anywheresoftware.b4a.keywords.Common.CRLF+"Under Settings - Security - Unknown sources"+anywheresoftware.b4a.keywords.Common.CRLF+"Or Settings - Applications - Unknown sources","Attention",mostCurrent.activityBA);
 }else {
 //BA.debugLineNum = 59;BA.debugLine="btnStartBluetooth.Enabled = True";
mostCurrent._btnstartbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 60;BA.debugLine="btnStartWireless.Enabled = True";
mostCurrent._btnstartwireless.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 61;BA.debugLine="btnResetBluetooth.Enabled = True";
mostCurrent._btnresetbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _badmin_statechanged(int _newstate,int _oldstate) throws Exception{
 //BA.debugLineNum = 145;BA.debugLine="Sub BAdmin_StateChanged (NewState As Int, OldState As Int)";
 //BA.debugLineNum = 146;BA.debugLine="If NewState = BAdmin.STATE_ON AND waitingForBluetoothToBeReady Then";
if (_newstate==_badmin.STATE_ON && _waitingforbluetoothtobeready) { 
 //BA.debugLineNum = 147;BA.debugLine="btnStartBluetooth_Click";
_btnstartbluetooth_click();
 //BA.debugLineNum = 148;BA.debugLine="waitingForBluetoothToBeReady = False";
_waitingforbluetoothtobeready = anywheresoftware.b4a.keywords.Common.False;
 };
 //BA.debugLineNum = 150;BA.debugLine="If waitingForReset Then";
if (_waitingforreset) { 
 //BA.debugLineNum = 151;BA.debugLine="If NewState = BAdmin.STATE_OFF Then";
if (_newstate==_badmin.STATE_OFF) { 
 //BA.debugLineNum = 152;BA.debugLine="resetTimer.Enabled = True";
_resettimer.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 }else if(_newstate==_badmin.STATE_ON) { 
 //BA.debugLineNum = 154;BA.debugLine="waitingForReset = False";
_waitingforreset = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 155;BA.debugLine="btnStartBluetooth.Enabled = True";
mostCurrent._btnstartbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 };
 //BA.debugLineNum = 158;BA.debugLine="End Sub";
return "";
}
public static String  _btnresetbluetooth_click() throws Exception{
 //BA.debugLineNum = 175;BA.debugLine="Sub btnResetBluetooth_Click";
 //BA.debugLineNum = 176;BA.debugLine="btnStop_Click";
_btnstop_click();
 //BA.debugLineNum = 177;BA.debugLine="waitingForBluetoothToBeReady = False";
_waitingforbluetoothtobeready = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 178;BA.debugLine="If BAdmin.IsEnabled = False Then";
if (_badmin.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 179;BA.debugLine="BAdmin.Enable";
_badmin.Enable();
 }else {
 //BA.debugLineNum = 181;BA.debugLine="BAdmin.Disable";
_badmin.Disable();
 //BA.debugLineNum = 182;BA.debugLine="waitingForReset = True";
_waitingforreset = anywheresoftware.b4a.keywords.Common.True;
 };
 //BA.debugLineNum = 184;BA.debugLine="End Sub";
return "";
}
public static String  _btnrestart_click() throws Exception{
 //BA.debugLineNum = 185;BA.debugLine="Sub btnRestart_Click";
 //BA.debugLineNum = 186;BA.debugLine="Select Case LastEnabled";
switch (_lastenabled) {
case 0:
 //BA.debugLineNum = 188;BA.debugLine="ToastMessageShow(\"Restarting nothing. Maybe an error ocurred!\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Restarting nothing. Maybe an error ocurred!",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 189;BA.debugLine="btnStop_Click";
_btnstop_click();
 break;
case 1:
 //BA.debugLineNum = 191;BA.debugLine="ToastMessageShow(\"Restarting Wireless.\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Restarting Wireless.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 192;BA.debugLine="btnStartWireless_Click";
_btnstartwireless_click();
 break;
case 2:
 //BA.debugLineNum = 194;BA.debugLine="ToastMessageShow(\"Restarting Bluetooth.\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Restarting Bluetooth.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 195;BA.debugLine="btnStartBluetooth_Click";
_btnstartbluetooth_click();
 break;
}
;
 //BA.debugLineNum = 198;BA.debugLine="End Sub";
return "";
}
public static String  _btnstartbluetooth_click() throws Exception{
anywheresoftware.b4a.objects.IntentWrapper _i = null;
 //BA.debugLineNum = 118;BA.debugLine="Sub btnStartBluetooth_Click";
 //BA.debugLineNum = 119;BA.debugLine="If BAdmin.IsEnabled = False Then";
if (_badmin.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 120;BA.debugLine="waitingForBluetoothToBeReady = True";
_waitingforbluetoothtobeready = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 121;BA.debugLine="ToastMessageShow(\"Enabling Bluetooth adapter.\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Enabling Bluetooth adapter.",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 122;BA.debugLine="BAdmin.Enable";
_badmin.Enable();
 //BA.debugLineNum = 123;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 126;BA.debugLine="If chkDiscoverable.Checked Then";
if (mostCurrent._chkdiscoverable.getChecked()) { 
 //BA.debugLineNum = 128;BA.debugLine="Dim i As Intent";
_i = new anywheresoftware.b4a.objects.IntentWrapper();
 //BA.debugLineNum = 129;BA.debugLine="i.Initialize(\"android.bluetooth.adapter.action.REQUEST_DISCOVERABLE\", \"\")";
_i.Initialize("android.bluetooth.adapter.action.REQUEST_DISCOVERABLE","");
 //BA.debugLineNum = 130;BA.debugLine="i.PutExtra(\"android.bluetooth.adapter.extra.DISCOVERABLE_DURATION\", 300)";
_i.PutExtra("android.bluetooth.adapter.extra.DISCOVERABLE_DURATION",(Object)(300));
 //BA.debugLineNum = 131;BA.debugLine="StartActivity(i)";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(_i.getObject()));
 };
 //BA.debugLineNum = 134;BA.debugLine="StopService(Service1)";
anywheresoftware.b4a.keywords.Common.StopService(mostCurrent.activityBA,(Object)(mostCurrent._service1.getObject()));
 //BA.debugLineNum = 135;BA.debugLine="LastEnabled=2";
_lastenabled = (int) (2);
 //BA.debugLineNum = 136;BA.debugLine="Service1.wifi = False";
mostCurrent._service1._wifi = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 137;BA.debugLine="StartService(Service1)";
anywheresoftware.b4a.keywords.Common.StartService(mostCurrent.activityBA,(Object)(mostCurrent._service1.getObject()));
 //BA.debugLineNum = 138;BA.debugLine="btnStop.Enabled=True";
mostCurrent._btnstop.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 139;BA.debugLine="btnStartWireless.Enabled=False";
mostCurrent._btnstartwireless.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 140;BA.debugLine="btnStartBluetooth.Enabled=False";
mostCurrent._btnstartbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 141;BA.debugLine="btnResetBluetooth.Enabled=False";
mostCurrent._btnresetbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 142;BA.debugLine="btnRestart.Enabled=True";
mostCurrent._btnrestart.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 143;BA.debugLine="End Sub";
return "";
}
public static String  _btnstartwireless_click() throws Exception{
 //BA.debugLineNum = 164;BA.debugLine="Sub btnStartWireless_Click";
 //BA.debugLineNum = 165;BA.debugLine="LastEnabled=1";
_lastenabled = (int) (1);
 //BA.debugLineNum = 166;BA.debugLine="StopService(Service1)";
anywheresoftware.b4a.keywords.Common.StopService(mostCurrent.activityBA,(Object)(mostCurrent._service1.getObject()));
 //BA.debugLineNum = 167;BA.debugLine="Service1.wifi = True";
mostCurrent._service1._wifi = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 168;BA.debugLine="StartService(Service1)";
anywheresoftware.b4a.keywords.Common.StartService(mostCurrent.activityBA,(Object)(mostCurrent._service1.getObject()));
 //BA.debugLineNum = 169;BA.debugLine="btnStop.Enabled=True";
mostCurrent._btnstop.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 170;BA.debugLine="btnStartWireless.Enabled=False";
mostCurrent._btnstartwireless.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 171;BA.debugLine="btnStartBluetooth.Enabled=False";
mostCurrent._btnstartbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 172;BA.debugLine="btnResetBluetooth.Enabled=False";
mostCurrent._btnresetbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 173;BA.debugLine="btnRestart.Enabled=True";
mostCurrent._btnrestart.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 174;BA.debugLine="End Sub";
return "";
}
public static String  _btnstop_click() throws Exception{
 //BA.debugLineNum = 108;BA.debugLine="Sub btnStop_Click";
 //BA.debugLineNum = 109;BA.debugLine="LastEnabled=0";
_lastenabled = (int) (0);
 //BA.debugLineNum = 110;BA.debugLine="StopService(Service1)";
anywheresoftware.b4a.keywords.Common.StopService(mostCurrent.activityBA,(Object)(mostCurrent._service1.getObject()));
 //BA.debugLineNum = 111;BA.debugLine="btnStop.Enabled=False";
mostCurrent._btnstop.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 112;BA.debugLine="btnStartWireless.Enabled=True";
mostCurrent._btnstartwireless.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 113;BA.debugLine="btnStartBluetooth.Enabled=True";
mostCurrent._btnstartbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 114;BA.debugLine="btnResetBluetooth.Enabled=True";
mostCurrent._btnresetbluetooth.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 115;BA.debugLine="btnRestart.Enabled=False";
mostCurrent._btnrestart.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 116;BA.debugLine="End Sub";
return "";
}
public static boolean  _checknonmarketappsenabled() throws Exception{
anywheresoftware.b4a.phone.Phone _p = null;
anywheresoftware.b4j.object.JavaObject _context = null;
anywheresoftware.b4j.object.JavaObject _resolver = null;
anywheresoftware.b4j.object.JavaObject _global = null;
 //BA.debugLineNum = 65;BA.debugLine="Private Sub CheckNonMarketAppsEnabled As Boolean";
 //BA.debugLineNum = 67;BA.debugLine="Dim p As Phone";
_p = new anywheresoftware.b4a.phone.Phone();
 //BA.debugLineNum = 68;BA.debugLine="If p.SdkVersion < 17 Then";
if (_p.getSdkVersion()<17) { 
 //BA.debugLineNum = 69;BA.debugLine="Return p.GetSettings(\"install_non_market_apps\") = \"1\"";
if (true) return (_p.GetSettings("install_non_market_apps")).equals("1");
 }else {
 //BA.debugLineNum = 71;BA.debugLine="Dim context As JavaObject";
_context = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 72;BA.debugLine="context.InitializeStatic(\"anywheresoftware.b4a.BA\")";
_context.InitializeStatic("anywheresoftware.b4a.BA");
 //BA.debugLineNum = 73;BA.debugLine="context = context.GetField(\"applicationContext\")";
_context.setObject((java.lang.Object)(_context.GetField("applicationContext")));
 //BA.debugLineNum = 74;BA.debugLine="Dim resolver As JavaObject = context.RunMethod(\"getContentResolver\", Null)";
_resolver = new anywheresoftware.b4j.object.JavaObject();
_resolver.setObject((java.lang.Object)(_context.RunMethod("getContentResolver",(Object[])(anywheresoftware.b4a.keywords.Common.Null))));
 //BA.debugLineNum = 75;BA.debugLine="Dim global As JavaObject";
_global = new anywheresoftware.b4j.object.JavaObject();
 //BA.debugLineNum = 76;BA.debugLine="global.InitializeStatic(\"android.provider.Settings.Global\")";
_global.InitializeStatic("android.provider.Settings.Global");
 //BA.debugLineNum = 77;BA.debugLine="Return global.RunMethod(\"getString\", Array As Object(resolver, \"install_non_market_apps\")) = \"1\"";
if (true) return (_global.RunMethod("getString",new Object[]{(Object)(_resolver.getObject()),(Object)("install_non_market_apps")})).equals((Object)("1"));
 };
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return false;
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
service1._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 24;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Dim lblIp As Label";
mostCurrent._lblip = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim lblStatus As Label";
mostCurrent._lblstatus = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim lblVersion As Label";
mostCurrent._lblversion = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim btnStartBluetooth As Button";
mostCurrent._btnstartbluetooth = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim btnStartWireless As Button";
mostCurrent._btnstartwireless = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Dim chkDiscoverable As CheckBox";
mostCurrent._chkdiscoverable = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 32;BA.debugLine="Dim btnResetBluetooth As Button";
mostCurrent._btnresetbluetooth = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Private btnStop As Button";
mostCurrent._btnstop = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Private btnRestart As Button";
mostCurrent._btnrestart = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 35;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 13;BA.debugLine="Dim server As ServerSocket 'Only used to show the device IP.";
_server = new anywheresoftware.b4a.objects.SocketWrapper.ServerSocketWrapper();
 //BA.debugLineNum = 14;BA.debugLine="Dim folder As String";
_folder = "";
 //BA.debugLineNum = 15;BA.debugLine="folder = File.DirDefaultExternal";
_folder = anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal();
 //BA.debugLineNum = 16;BA.debugLine="Dim version As String = \"2.11\" 'added the touch required=false to the manifest.";
_version = "2.11";
 //BA.debugLineNum = 17;BA.debugLine="Dim BAdmin As BluetoothAdmin";
_badmin = new anywheresoftware.b4a.objects.Serial.BluetoothAdmin();
 //BA.debugLineNum = 18;BA.debugLine="Dim waitingForBluetoothToBeReady As Boolean";
_waitingforbluetoothtobeready = false;
 //BA.debugLineNum = 19;BA.debugLine="Dim waitingForReset As Boolean";
_waitingforreset = false;
 //BA.debugLineNum = 20;BA.debugLine="Dim resetTimer As Timer";
_resettimer = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 21;BA.debugLine="Dim LastEnabled As Int";
_lastenabled = 0;
 //BA.debugLineNum = 22;BA.debugLine="End Sub";
return "";
}
public static String  _resettimer_tick() throws Exception{
 //BA.debugLineNum = 159;BA.debugLine="Sub ResetTimer_Tick";
 //BA.debugLineNum = 160;BA.debugLine="resetTimer.Enabled = False";
_resettimer.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 161;BA.debugLine="BAdmin.Enable";
_badmin.Enable();
 //BA.debugLineNum = 162;BA.debugLine="End Sub";
return "";
}
public static String  _updateip() throws Exception{
String _ip = "";
 //BA.debugLineNum = 81;BA.debugLine="Sub UpdateIp";
 //BA.debugLineNum = 82;BA.debugLine="Dim ip As String";
_ip = "";
 //BA.debugLineNum = 83;BA.debugLine="ip = server.GetMyWifiIP";
_ip = _server.GetMyWifiIP();
 //BA.debugLineNum = 84;BA.debugLine="If ip = \"127.0.0.1\" OR ip.Contains(\":\") Then";
if ((_ip).equals("127.0.0.1") || _ip.contains(":")) { 
 //BA.debugLineNum = 85;BA.debugLine="ip = \"Not connected to wireless network.\"";
_ip = "Not connected to wireless network.";
 };
 //BA.debugLineNum = 87;BA.debugLine="lblIp.Text = \"My IP: \" & ip";
mostCurrent._lblip.setText((Object)("My IP: "+_ip));
 //BA.debugLineNum = 88;BA.debugLine="End Sub";
return "";
}
public static String  _updatestatus() throws Exception{
 //BA.debugLineNum = 89;BA.debugLine="Sub UpdateStatus";
 //BA.debugLineNum = 90;BA.debugLine="If Service1.ConnectedStatus Then";
if (mostCurrent._service1._connectedstatus) { 
 //BA.debugLineNum = 91;BA.debugLine="lblStatus.Text = \"Status: Connected\"";
mostCurrent._lblstatus.setText((Object)("Status: Connected"));
 }else {
 //BA.debugLineNum = 93;BA.debugLine="If IsPaused(Service1) = False Then";
if (anywheresoftware.b4a.keywords.Common.IsPaused(mostCurrent.activityBA,(Object)(mostCurrent._service1.getObject()))==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 94;BA.debugLine="If Service1.wifi Then";
if (mostCurrent._service1._wifi) { 
 //BA.debugLineNum = 95;BA.debugLine="lblStatus.Text = \"Status: Disconnected.\" & CRLF & \"Waiting For wireless connections.\"";
mostCurrent._lblstatus.setText((Object)("Status: Disconnected."+anywheresoftware.b4a.keywords.Common.CRLF+"Waiting For wireless connections."));
 }else {
 //BA.debugLineNum = 97;BA.debugLine="lblStatus.Text = \"Status: Disconnected.\" & CRLF & \"Waiting For Bluetooth connections.\"";
mostCurrent._lblstatus.setText((Object)("Status: Disconnected."+anywheresoftware.b4a.keywords.Common.CRLF+"Waiting For Bluetooth connections."));
 };
 }else {
 //BA.debugLineNum = 100;BA.debugLine="lblStatus.Text = \"Status: Disconnected.\" & CRLF & \"Press on Start to listen for connections.\"";
mostCurrent._lblstatus.setText((Object)("Status: Disconnected."+anywheresoftware.b4a.keywords.Common.CRLF+"Press on Start to listen for connections."));
 };
 };
 //BA.debugLineNum = 103;BA.debugLine="End Sub";
return "";
}
}
